<center><a href="baijfact3.c">Actual source code: baijfact3.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:24:35+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80"><a name="line1">  1: </a><strong><font color="#228B22">#define PETSCMAT_DLL</font></strong>

<a name="line3">  3: </a><font color="#B22222">/*</font>
<a name="line4">  4: </a><font color="#B22222">    Factorization code for BAIJ format. </font>
<a name="line5">  5: </a><font color="#B22222">*/</font>
<a name="line6"> 6: </a> #include <A href="../../../../../src/mat/impls/baij/seq/baij.h.html">src/mat/impls/baij/seq/baij.h</A>
<a name="line7"> 7: </a> #include <A href="../../../../../src/inline/ilu.h.html">src/inline/ilu.h</A>

<a name="line9">  9: </a><font color="#B22222">/*</font>
<a name="line10"> 10: </a><font color="#B22222">    The symbolic factorization code is identical to that for AIJ format,</font>
<a name="line11"> 11: </a><font color="#B22222">  except for very small changes since this is now a SeqBAIJ datastructure.</font>
<a name="line12"> 12: </a><font color="#B22222">  NOT good code reuse.</font>
<a name="line13"> 13: </a><font color="#B22222">*/</font>
<a name="line16"> 16: </a><strong><font color="#4169E1"><a name="MatLUFactorSymbolic_SeqBAIJ"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatLUFactorSymbolic_SeqBAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> A,<A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A> isrow,<A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A> iscol,<A href="../../../../../docs/manualpages/Mat/MatFactorInfo.html#MatFactorInfo">MatFactorInfo</A> *info,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> *B)</font></strong>
<a name="line17"> 17: </a>{
<a name="line18"> 18: </a>  Mat_SeqBAIJ    *a = (Mat_SeqBAIJ*)A-&gt;data,*b;
<a name="line19"> 19: </a>  <A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A>             isicol;
<a name="line21"> 21: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       *r,*ic,i,n = a-&gt;mbs,*ai = a-&gt;i,*aj = a-&gt;j;
<a name="line22"> 22: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       *ainew,*ajnew,jmax,*fill,*ajtmp,nz,bs = A-&gt;rmap.bs,bs2=a-&gt;bs2;
<a name="line23"> 23: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       *idnew,idx,row,m,fm,nnz,nzi,reallocs = 0,nzbd,*im;
<a name="line24"> 24: </a>  <A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>      f = 1.0;

<a name="line27"> 27: </a>  <font color="#4169E1">if</font> (A-&gt;rmap.N != A-&gt;cmap.N) <A href="../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_ARG_WRONG,<font color="#666666">"matrix must be square"</font>);
<a name="line28"> 28: </a>  <A href="../../../../../docs/manualpages/IS/ISInvertPermutation.html#ISInvertPermutation">ISInvertPermutation</A>(iscol,<A href="../../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>,&amp;isicol);
<a name="line29"> 29: </a>  <A href="../../../../../docs/manualpages/IS/ISGetIndices.html#ISGetIndices">ISGetIndices</A>(isrow,&amp;r);
<a name="line30"> 30: </a>  <A href="../../../../../docs/manualpages/IS/ISGetIndices.html#ISGetIndices">ISGetIndices</A>(isicol,&amp;ic);

<a name="line32"> 32: </a>  f = info-&gt;fill;
<a name="line33"> 33: </a>  <font color="#B22222">/* get new row pointers */</font>
<a name="line34"> 34: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>((n+1)*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;ainew);
<a name="line35"> 35: </a>  ainew[0] = 0;
<a name="line36"> 36: </a>  <font color="#B22222">/* don't know how many column pointers are needed so estimate */</font>
<a name="line37"> 37: </a>  jmax     = (<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>)(f*ai[n] + 1);
<a name="line38"> 38: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>((jmax)*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;ajnew);
<a name="line39"> 39: </a>  <font color="#B22222">/* fill is a linked list of nonzeros in active row */</font>
<a name="line40"> 40: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>((2*n+1)*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;fill);
<a name="line41"> 41: </a>  im       = fill + n + 1;
<a name="line42"> 42: </a>  <font color="#B22222">/* idnew is location of diagonal in factor */</font>
<a name="line43"> 43: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>((n+1)*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;idnew);
<a name="line44"> 44: </a>  idnew[0] = 0;

<a name="line46"> 46: </a>  <font color="#4169E1">for</font> (i=0; i&lt;n; i++) {
<a name="line47"> 47: </a>    <font color="#B22222">/* first copy previous fill into linked list */</font>
<a name="line48"> 48: </a>    nnz     = nz    = ai[r[i]+1] - ai[r[i]];
<a name="line49"> 49: </a>    <font color="#4169E1">if</font> (!nz) <A href="../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_MAT_LU_ZRPVT,<font color="#666666">"Empty row in matrix"</font>);
<a name="line50"> 50: </a>    ajtmp   = aj + ai[r[i]];
<a name="line51"> 51: </a>    fill[n] = n;
<a name="line52"> 52: </a>    <font color="#4169E1">while</font> (nz--) {
<a name="line53"> 53: </a>      fm  = n;
<a name="line54"> 54: </a>      idx = ic[*ajtmp++];
<a name="line55"> 55: </a>      <font color="#4169E1">do</font> {
<a name="line56"> 56: </a>        m  = fm;
<a name="line57"> 57: </a>        fm = fill[m];
<a name="line58"> 58: </a>      } <font color="#4169E1">while</font> (fm &lt; idx);
<a name="line59"> 59: </a>      fill[m]   = idx;
<a name="line60"> 60: </a>      fill[idx] = fm;
<a name="line61"> 61: </a>    }
<a name="line62"> 62: </a>    row = fill[n];
<a name="line63"> 63: </a>    <font color="#4169E1">while</font> (row &lt; i) {
<a name="line64"> 64: </a>      ajtmp = ajnew + idnew[row] + 1;
<a name="line65"> 65: </a>      nzbd  = 1 + idnew[row] - ainew[row];
<a name="line66"> 66: </a>      nz    = im[row] - nzbd;
<a name="line67"> 67: </a>      fm    = row;
<a name="line68"> 68: </a>      <font color="#4169E1">while</font> (nz-- &gt; 0) {
<a name="line69"> 69: </a>        idx = *ajtmp++;
<a name="line70"> 70: </a>        nzbd++;
<a name="line71"> 71: </a>        <font color="#4169E1">if</font> (idx == i) im[row] = nzbd;
<a name="line72"> 72: </a>        <font color="#4169E1">do</font> {
<a name="line73"> 73: </a>          m  = fm;
<a name="line74"> 74: </a>          fm = fill[m];
<a name="line75"> 75: </a>        } <font color="#4169E1">while</font> (fm &lt; idx);
<a name="line76"> 76: </a>        <font color="#4169E1">if</font> (fm != idx) {
<a name="line77"> 77: </a>          fill[m]   = idx;
<a name="line78"> 78: </a>          fill[idx] = fm;
<a name="line79"> 79: </a>          fm        = idx;
<a name="line80"> 80: </a>          nnz++;
<a name="line81"> 81: </a>        }
<a name="line82"> 82: </a>      }
<a name="line83"> 83: </a>      row = fill[row];
<a name="line84"> 84: </a>    }
<a name="line85"> 85: </a>    <font color="#B22222">/* copy new filled row into permanent storage */</font>
<a name="line86"> 86: </a>    ainew[i+1] = ainew[i] + nnz;
<a name="line87"> 87: </a>    <font color="#4169E1">if</font> (ainew[i+1] &gt; jmax) {

<a name="line89"> 89: </a>      <font color="#B22222">/* estimate how much additional space we will need */</font>
<a name="line90"> 90: </a>      <font color="#B22222">/* use the strategy suggested by David Hysom &lt;hysom@perch-t.icase.edu&gt; */</font>
<a name="line91"> 91: </a>      <font color="#B22222">/* just double the memory each time */</font>
<a name="line92"> 92: </a>      <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> maxadd = jmax;
<a name="line93"> 93: </a>      <font color="#B22222">/* maxadd = (int)((f*(ai[n]+1)*(n-i+5))/n); */</font>
<a name="line94"> 94: </a>      <font color="#4169E1">if</font> (maxadd &lt; nnz) maxadd = (n-i)*(nnz+1);
<a name="line95"> 95: </a>      jmax += maxadd;

<a name="line97"> 97: </a>      <font color="#B22222">/* allocate a longer ajnew */</font>
<a name="line98"> 98: </a>      <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(jmax*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;ajtmp);
<a name="line99"> 99: </a>      <A href="../../../../../docs/manualpages/Sys/PetscMemcpy.html#PetscMemcpy">PetscMemcpy</A>(ajtmp,ajnew,ainew[i]*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>));
<a name="line100">100: </a>      <A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(ajnew);
<a name="line101">101: </a>      ajnew = ajtmp;
<a name="line102">102: </a>      reallocs++; <font color="#B22222">/* count how many times we realloc */</font>
<a name="line103">103: </a>    }
<a name="line104">104: </a>    ajtmp = ajnew + ainew[i];
<a name="line105">105: </a>    fm    = fill[n];
<a name="line106">106: </a>    nzi   = 0;
<a name="line107">107: </a>    im[i] = nnz;
<a name="line108">108: </a>    <font color="#4169E1">while</font> (nnz--) {
<a name="line109">109: </a>      <font color="#4169E1">if</font> (fm &lt; i) nzi++;
<a name="line110">110: </a>      *ajtmp++ = fm;
<a name="line111">111: </a>      fm       = fill[fm];
<a name="line112">112: </a>    }
<a name="line113">113: </a>    idnew[i] = ainew[i] + nzi;
<a name="line114">114: </a>  }

<a name="line116">116: </a><font color="#A020F0">#if defined(PETSC_USE_INFO)</font>
<a name="line117">117: </a>  <font color="#4169E1">if</font> (ai[n] != 0) {
<a name="line118">118: </a>    <A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> af = ((<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>)ainew[n])/((<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>)ai[n]);
<a name="line119">119: </a>    PetscInfo3(A,<font color="#666666">"Reallocs %D Fill ratio:given %G needed %G\n"</font>,reallocs,f,af);
<a name="line120">120: </a>    PetscInfo1(A,<font color="#666666">"Run with -pc_factor_fill %G or use \n"</font>,af);
<a name="line121">121: </a>    PetscInfo1(A,<font color="#666666">"<A href="../../../../../docs/manualpages/PC/PCFactorSetFill.html#PCFactorSetFill">PCFactorSetFill</A>(pc,%G);\n"</font>,af);
<a name="line122">122: </a>    <A href="../../../../../docs/manualpages/Profiling/PetscInfo.html#PetscInfo">PetscInfo</A>(A,<font color="#666666">"for best performance.\n"</font>);
<a name="line123">123: </a>  } <font color="#4169E1">else</font> {
<a name="line124">124: </a>    <A href="../../../../../docs/manualpages/Profiling/PetscInfo.html#PetscInfo">PetscInfo</A>(A,<font color="#666666">"Empty matrix.\n"</font>);
<a name="line125">125: </a>  }
<a name="line126">126: </a><font color="#A020F0">#endif</font>

<a name="line128">128: </a>  <A href="../../../../../docs/manualpages/IS/ISRestoreIndices.html#ISRestoreIndices">ISRestoreIndices</A>(isrow,&amp;r);
<a name="line129">129: </a>  <A href="../../../../../docs/manualpages/IS/ISRestoreIndices.html#ISRestoreIndices">ISRestoreIndices</A>(isicol,&amp;ic);

<a name="line131">131: </a>  <A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(fill);

<a name="line133">133: </a>  <font color="#B22222">/* put together the new matrix */</font>
<a name="line134">134: </a>  <A href="../../../../../docs/manualpages/Mat/MatCreate.html#MatCreate">MatCreate</A>(A-&gt;<A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,B);
<a name="line135">135: </a>  <A href="../../../../../docs/manualpages/Mat/MatSetSizes.html#MatSetSizes">MatSetSizes</A>(*B,bs*n,bs*n,bs*n,bs*n);
<a name="line136">136: </a>  <A href="../../../../../docs/manualpages/Mat/MatSetType.html#MatSetType">MatSetType</A>(*B,A-&gt;type_name);
<a name="line137">137: </a>  MatSeqBAIJSetPreallocation_SeqBAIJ(*B,bs,MAT_SKIP_ALLOCATION,<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line138">138: </a>  PetscLogObjectParent(*B,isicol);
<a name="line139">139: </a>  b = (Mat_SeqBAIJ*)(*B)-&gt;data;
<a name="line140">140: </a>  b-&gt;singlemalloc = <A href="../../../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>;
<a name="line141">141: </a>  b-&gt;free_a     = <A href="../../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>;
<a name="line142">142: </a>  b-&gt;free_ij    = <A href="../../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>;
<a name="line143">143: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>((ainew[n]+1)*<font color="#4169E1">sizeof</font>(MatScalar)*bs2,&amp;b-&gt;a);
<a name="line144">144: </a>  b-&gt;j          = ajnew;
<a name="line145">145: </a>  b-&gt;i          = ainew;
<a name="line146">146: </a>  b-&gt;diag       = idnew;
<a name="line147">147: </a>  b-&gt;ilen       = 0;
<a name="line148">148: </a>  b-&gt;imax       = 0;
<a name="line149">149: </a>  b-&gt;row        = isrow;
<a name="line150">150: </a>  b-&gt;col        = iscol;
<a name="line151">151: </a>  b-&gt;pivotinblocks = (info-&gt;pivotinblocks) ? <A href="../../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A> : <A href="../../../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>;
<a name="line152">152: </a>  <A href="../../../../../docs/manualpages/Sys/PetscObjectReference.html#PetscObjectReference">PetscObjectReference</A>((<A href="../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)isrow);
<a name="line153">153: </a>  <A href="../../../../../docs/manualpages/Sys/PetscObjectReference.html#PetscObjectReference">PetscObjectReference</A>((<A href="../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)iscol);
<a name="line154">154: </a>  b-&gt;icol       = isicol;
<a name="line155">155: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>((bs*n+bs)*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>),&amp;b-&gt;solve_work);
<a name="line156">156: </a>  <font color="#B22222">/* In b structure:  Free imax, ilen, old a, old j.  </font>
<a name="line157">157: </a><font color="#B22222">     Allocate idnew, solve_work, new a, new j */</font>
<a name="line158">158: </a>  PetscLogObjectMemory(*B,(ainew[n]-n)*(<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>)+<font color="#4169E1">sizeof</font>(MatScalar)));
<a name="line159">159: </a>  b-&gt;maxnz = b-&gt;nz = ainew[n];
<a name="line160">160: </a>
<a name="line161">161: </a>  (*B)-&gt;factor                 = FACTOR_LU;
<a name="line162">162: </a>  (*B)-&gt;info.factor_mallocs    = reallocs;
<a name="line163">163: </a>  (*B)-&gt;info.fill_ratio_given  = f;
<a name="line164">164: </a>  <font color="#4169E1">if</font> (ai[n] != 0) {
<a name="line165">165: </a>    (*B)-&gt;info.fill_ratio_needed = ((<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>)ainew[n])/((<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>)ai[n]);
<a name="line166">166: </a>  } <font color="#4169E1">else</font> {
<a name="line167">167: </a>    (*B)-&gt;info.fill_ratio_needed = 0.0;
<a name="line168">168: </a>  }
<a name="line169">169: </a>  <font color="#4169E1">return</font>(0);
<a name="line170">170: </a>}
</pre>
</body>

</html>
